#ifndef _MAIN_H_
#define _MAIN_H_


////////////////////////////////////////////////////////////////////////////////
//pliki naglowkowe standardowych bibliotek

#define WINAVR_2007


#ifdef WINAVR_2007
    #include <inttypes.h>
    #include <avr/io.h>
    #include <util/delay.h>
    #include <avr/eeprom.h>
    #include <math.h>
    #include <string.h>
    #include <stdlib.h>
    #include <avr/interrupt.h>
#else
    #include <inttypes.h>
    #include <avr/io.h>
    #include <avr/delay.h>
    #include <avr/eeprom.h>
    #include <math.h>
    #include <string.h>
    #include <stdlib.h>
    #include <avr/interrupt.h>
    #include <avr/signal.h>
#endif
////////////////////////////////////////////////////////////////////////////////
//moje pliki naglowkowe
////////////////////////////////////////////////////////////////////////////////
#include <avr/wdt.h>
#include <avr/pgmspace.h>

#define UART

#include "Uart.h"
#include "Diagnostic.h"
#include "Motor.h"


/////////////////////////////////////////////////////////////////////////////////////////////////
//zwiazane z odmierzaniem czasu
/////////////////////////////////////////////////////////////////////////////////////////////////
inline void delay(unsigned int miliseconds);
void Delay(unsigned long miliseconds);

#define xtal 8000000
#define delay_mul ( xtal / 4000.0 )
#define delay_mul_us ( xtal / 4000000.0 )

////////////////////////////////////////////////////////////////////////////////
//Funkcje zwiazane z silnikeim
////////////////////////////////////////////////////////////////////////////////
void drive(signed int left_speed,signed int right_speed);
void motor_break (unsigned char left_motor ,unsigned char right_motor);
void drive_init(void);

////////////////////////////////////////////////////////////////////////////////
//Piny sterujace silnikiem
////////////////////////////////////////////////////////////////////////////////
#define DRIVE_PORT PORTA
#define DRIVE_DDR DDRA

#define IN1_A 4
#define IN1_B 3
#define IN2_A 6
#define IN2_B 5

#define DRIVE_DIAG_PORT PORTC
#define DRIVE_DIAG_DDR DDRC
#define DRIVE_DIAG_PIN PINC

#define DRIVE_DIAG_A_PIN 0
#define DRIVE_DIAG_B_PIN 1

#define DRIVE_PWM_PORT PORTE
#define DRIVE_PWM_DDR DDRE

#define DRIVE_PWMA_PIN 3
#define DRIVE_PWMB_PIN 4

signed int global_left_speed;
signed int global_right_speed;

unsigned char flaga_L, flaga_R;

#endif//_MAIN_H_
