////////////////////////////////////////////////////////////////////////////////
//Copyright (c) 2005
//	Lukasz Matecki
//	lutecki@op.pl
////////////////////////////////////////////////////////////////////////////////
//April 25, 2006 08:57:56 AM 
////////////////////////////////////////////////////////////////////////////////
#ifndef _UART_H_
#define _UART_H_

////////////////////////////////////////////////////////////////////////////////
//Uart
////////////////////////////////////////////////////////////////////////////////

#define UART_RX_BUFFER_SIZE 256 	//2,4,8,16,32,64,128 lub 256 bajtow
#define UART_TX_BUFFER_SIZE 64

	
#ifdef _AVR_IOM128_H_
#define UCSRA UCSR0A
#define UCSRB UCSR0B
#define UCSRC UCSR0C
#define UDR UDR0
#define UBRRL UBRR0L
#define SIG_UART_RECV SIG_UART0_RECV
#define SIG_UART_DATA SIG_UART0_DATA
#endif

#define UART_CR UART_transmit_byte('\r')
#define UART_LF UART_transmit_byte('\n')
#define UART_NULL UART_transmit_byte('\0')
#define UART_RET UART_transmit_byte('\r');UART_transmit_byte('\n')

#define UART_RX_DISABLE UCSRB&=~(1<<RXEN)
#define UART_RX_ENABLE UCSRB|=(1<<RXEN)
#define UART_TX_DISABLE UCSRB&=~(1<<TXEN)
#define UART_TX_ENABLE UCSRB|=(1<<TXEN)

#define UART_RX_INT_DISABLE UCSRB&=~(1<<RXCIE)
#define UART_RX_INT_ENABLE UCSRB|=(1<<RXCIE)

#define UART_TX_INT_DISABLE UCSRB&=~(1<<UDRIE)
#define UART_TX_INT_ENABLE UCSRB|=(1<<UDRIE)

#define SEND_ESC UART_transmit_byte(27);UART_transmit_byte('[')
#define UART_CLS SEND_ESC;UART_transmit_byte('2');UART_transmit_byte('J')
#define UART_CLEAR_TO_END SEND_ESC;UART_transmit_byte('K')
#define UART_RESET UART_transmit_byte(27);UART_transmit_byte('c')
#define UART_HOME UART_transmit_byte(27);UART_transmit_byte('H')


unsigned char uart_echo;


extern void UART_init(void);
extern void UART_disable(void);
extern unsigned char UART_receive_byte( void );
extern void UART_buffer_rx_byte(unsigned char data);
extern unsigned char UART_buffer_rx_block(unsigned char *tekst);
extern void UART_transmit_byte( unsigned char data );
extern unsigned char UART_data_in_rx_buffer(void);
extern unsigned char UART_data_in_tx_buffer(void);
extern unsigned char UART_bytes_in_rx_buffer(void);
extern unsigned char UART_bytes_in_tx_buffer(void);
extern unsigned char UART_print(unsigned char *tekst);
extern unsigned char UART_gets(unsigned char *buf,unsigned char ile);
extern void UART_return(void);
extern void UART_send_block(const void *var, unsigned char cnt);
extern void UART_receive_block(void *var, unsigned char cnt);



extern void UART_flush_rx_buffer(void);
extern void UART_flush_tx_buffer(void);




volatile unsigned char UART_TxHead;
volatile unsigned char UART_TxTail;
volatile unsigned char UART_RxHead;
volatile unsigned char UART_RxTail;


#endif
